<?php
/*
 * $RCSfile: GalleryDataItem.inc,v $
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @package GalleryCore
 * @subpackage ClassInterfaces
 * @version $Revision: 1.42 $ $Date: 2005/08/23 03:49:04 $
 * @author Bharat Mediratta <bharat@menalto.com>
 */

/**
 * Interface class for the GalleryDataItem class.
 * (Class schema version: 1.0)
 *
 * This file is automatically generated from XML embedded in the
 * class, combined with the ClassCode.xsl file.  You should not modify
 * it by hand, as your changes will be lost next time this file is
 * rebuilt.  If you want to add more getters/setters, you should add
 * them in the core class.  If you want to change the format of this
 * file, then you should edit the XSL template.
 *
 * @package GalleryCore
 * @subpackage Classes
 */
class GalleryDataItem extends GalleryDataItem_core {
  
    /**
     * Return meta information about the members of this class
     *
     * @return array member => array(type, class)
     */
    function getPersistentMemberInfo() {
	$meta = parent::getPersistentMemberInfo();
	$meta['members']['mimeType'] = array('class' => 'GalleryDataItem', 'type' => STORAGE_TYPE_STRING);
    
	$meta['members']['size'] = array('class' => 'GalleryDataItem', 'type' => STORAGE_TYPE_INTEGER);
    
	return $meta;
    }

    /**
     * Get the data from this persistent object as an associative array
     *
     * @return array memberName => memberValue
     */
    function getMemberData() {
	$data = parent::getMemberData();if (isset($this->_linkedEntity)) {
            $data['mimeType'] = isset($this->_linkedEntity->_mimeType) ? $this->_linkedEntity->_mimeType : null;
	} else {
            $data['mimeType'] = isset($this->_mimeType) ? $this->_mimeType : null;
        }
	if (isset($this->_linkedEntity)) {
            $data['size'] = isset($this->_linkedEntity->_size) ? $this->_linkedEntity->_size : null;
	} else {
            $data['size'] = isset($this->_size) ? $this->_size : null;
        }
	
	return $data;
    }
  
    /**
     * Return the name of this class with the proper mix of uppercase and
     * lowercase (get_class() always returns lowercase)
     *
     * @return string class name
     */
    function getClassName() {
	return 'GalleryDataItem';
    }

    /** 
     * Return the path to the PHP file for this class, relative to the gallery2 dir
     * 
     * @return string path
     */ 
    function getClassFile() { 
        return 'modules/' .  
            basename(dirname(dirname(dirname(__FILE__)))) .  
            '/classes/GalleryDataItem.class'; 
    }
    
    /**
     * Get the value of mimeType
     *
     * @return STRING the value
     */
    function getmimeType() {
	$linkedEntity = $this->getLinkedEntity();
	if (isset($linkedEntity)) {
	    return $linkedEntity->getmimeType();
	}
	
	if (!isset($this->_mimeType)) {
	    return null;
	}
	return $this->_mimeType;
    }

    /**
     * Set the value of mimeType
     *
     * @param STRING the value
     */
    function setmimeType($value) {
	/* Convert unset values to null, to avoid generating warnings. */
	$value = isset($value) ? $value : null;
        $value = $this->_truncateString($value, 128);
	$orig = isset($this->_mimeType) ? $this->_mimeType : null;

        /* Only take action if the value actually changes */
        if ($value != $orig) {
	    $this->setModifiedFlag('mimeType', $value);
	    $this->_mimeType = $value;
	}
    }
  
    /**
     * Get the value of size
     *
     * @return INTEGER the value
     */
    function getsize() {
	$linkedEntity = $this->getLinkedEntity();
	if (isset($linkedEntity)) {
	    return $linkedEntity->getsize();
	}
	
	if (!isset($this->_size)) {
	    return null;
	}
	return $this->_size;
    }

    /**
     * Set the value of size
     *
     * @param INTEGER the value
     */
    function setsize($value) {
	/* Type cast the incoming value to be an integer */
	if ($value != null) {
	    $value = (int)$value;
	}
        
	/* Convert unset values to null, to avoid generating warnings. */
	$value = isset($value) ? $value : null;
      
	$orig = isset($this->_size) ? $this->_size : null;

        /* Only take action if the value actually changes */
        if ($value !== $orig) {
	    $this->setModifiedFlag('size', $value);
	    $this->_size = $value;
	}
    }
  
}
?>
